## rustc-1.79 1.79.0+dfsg1ubuntu1

=== tests/run-make/doctests-keep-binaries/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Check that valid binaries are persisted by running them, regardless of whether the --run or --no-run option is used.

MY_SRC_DIR := ${CURDIR}

all: run no_run test_run_directory

run:
	mkdir -p $(TMPDIR)/doctests
	$(RUSTC) --crate-type rlib t.rs
	$(RUSTDOC) -Zunstable-options --test --persist-doctests $(TMPDIR)/doctests --extern t=$(TMPDIR)/libt.rlib t.rs
	$(TMPDIR)/doctests/t_rs_2_0/rust_out
	$(TMPDIR)/doctests/t_rs_8_0/rust_out
	rm -rf $(TMPDIR)/doctests

no_run:
	mkdir -p $(TMPDIR)/doctests
	$(RUSTC) --crate-type rlib t.rs
	$(RUSTDOC) -Zunstable-options --test --persist-doctests $(TMPDIR)/doctests --extern t=$(TMPDIR)/libt.rlib t.rs --no-run
	$(TMPDIR)/doctests/t_rs_2_0/rust_out
	$(TMPDIR)/doctests/t_rs_8_0/rust_out
	rm -rf $(TMPDIR)/doctests

# Behavior with --test-run-directory with relative paths.
test_run_directory:
	mkdir -p $(TMPDIR)/doctests
	mkdir -p $(TMPDIR)/rundir
	$(RUSTC) --crate-type rlib t.rs
	( cd $(TMPDIR); \
		$(RUSTDOC) -Zunstable-options --test --persist-doctests doctests --test-run-directory rundir --extern t=libt.rlib $(MY_SRC_DIR)/t.rs )
	rm -rf $(TMPDIR)/doctests $(TMPDIR)/rundir

=== tests/run-make/libtest-thread-limit/Makefile ===
include ../tools.mk

# only-linux

all:
	$(RUSTC) test.rs --test --target $(TARGET)
	$(shell ulimit -p 0 && $(call RUN,test))

=== tests/run-make/link-framework/Makefile ===
# only-macos
#
# Check that linking to a framework actually makes it to the linker.

include ../tools.mk

all:
	$(RUSTC) dep-link-framework.rs
	$(RUSTC) dep-link-weak-framework.rs

	$(RUSTC) empty.rs
	otool -L $(TMPDIR)/no-link | $(CGREP) -v CoreFoundation

	$(RUSTC) link-framework.rs
	otool -L $(TMPDIR)/link-framework | $(CGREP) CoreFoundation | $(CGREP) -v weak

	$(RUSTC) link-weak-framework.rs
	otool -L $(TMPDIR)/link-weak-framework | $(CGREP) CoreFoundation | $(CGREP) weak

# When linking the framework both normally, and weakly, the weak linking takes preference

	$(RUSTC) link-both.rs
	otool -L $(TMPDIR)/link-both | $(CGREP) CoreFoundation | $(CGREP) weak

=== tests/run-make/linkage-attr-on-static/Makefile ===
# ignore-cross-compile
include ../tools.mk

all: $(call NATIVE_STATICLIB,foo)
	$(RUSTC) bar.rs
	$(call RUN,bar) || exit 1

=== tests/run-make/many-crates-but-no-match/Makefile ===
include ../tools.mk

# Modelled after ui/changing-crates.rs test, but this one puts
# more than one (mismatching) candidate crate into the search path,
# which did not appear directly expressible in UI testing infrastructure.
#
# Note that we move the built libraries into target direcrtories rather than
# use the `--out-dir` option because the `../tools.mk` file already bakes a
# use of `--out-dir` into the definition of $(RUSTC).

A1=$(TMPDIR)/a1
A2=$(TMPDIR)/a2
A3=$(TMPDIR)/a3

# A hack to match distinct lines of output from a single run.
LOG=$(TMPDIR)/log.txt

all:
	mkdir -p $(A1) $(A2) $(A3)
	$(RUSTC) --crate-type=rlib crateA1.rs
	mv $(TMPDIR)/$(call RLIB_GLOB,crateA) $(A1)
	$(RUSTC) --crate-type=rlib -L $(A1) crateB.rs
	$(RUSTC) --crate-type=rlib crateA2.rs
	mv $(TMPDIR)/$(call RLIB_GLOB,crateA) $(A2)
	$(RUSTC) --crate-type=rlib crateA3.rs
	mv $(TMPDIR)/$(call RLIB_GLOB,crateA) $(A3)
	# Ensure crateC fails to compile since A1 is "missing" and A2/A3 hashes do not match
	$(RUSTC) -L $(A2) -L $(A3) crateC.rs >$(LOG) 2>&1 || true
	$(CGREP) \
		'found possibly newer version of crate `crateA` which `crateB` depends on' \
		'note: perhaps that crate needs to be recompiled?' \
		'crate `crateA`:' \
		'crate `crateB`:' \
		< $(LOG)
	# the 'crate `crateA`' will match two entries.

=== tests/run-make/missing-crate-dependency/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --crate-type=rlib crateA.rs
	$(RUSTC) --crate-type=rlib crateB.rs
	$(call REMOVE_RLIBS,crateA)
	# Ensure crateC fails to compile since dependency crateA is missing
	$(RUSTC) crateC.rs 2>&1 | \
		$(CGREP) 'can'"'"'t find crate for `crateA` which `crateB` depends on'

=== tests/run-make/pgo-indirect-call-promotion/Makefile ===
# needs-profiler-support
# ignore-windows-gnu
# ignore-cross-compile

# FIXME(mati865): MinGW GCC miscompiles compiler-rt profiling library but with Clang it works
# properly. Since we only have GCC on the CI ignore the test for now.

include ../tools.mk

all:
	# We don't compile `opaque` with either optimizations or instrumentation.
	# We don't compile `opaque` with either optimizations or instrumentation.
	$(RUSTC) $(COMMON_FLAGS) opaque.rs
	# Compile the test program with instrumentation
	mkdir -p "$(TMPDIR)"/prof_data_dir
	$(RUSTC) $(COMMON_FLAGS) interesting.rs \
		-Cprofile-generate="$(TMPDIR)"/prof_data_dir -O -Ccodegen-units=1
	$(RUSTC) $(COMMON_FLAGS) main.rs -Cprofile-generate="$(TMPDIR)"/prof_data_dir -O
	# The argument below generates to the expected branch weights
	$(call RUN,main) || exit 1
	"$(LLVM_BIN_DIR)"/llvm-profdata merge \
		-o "$(TMPDIR)"/prof_data_dir/merged.profdata \
		"$(TMPDIR)"/prof_data_dir
	$(RUSTC) $(COMMON_FLAGS) interesting.rs \
		-Cprofile-use="$(TMPDIR)"/prof_data_dir/merged.profdata -O \
		-Ccodegen-units=1 --emit=llvm-ir
	cat "$(TMPDIR)"/interesting.ll | "$(LLVM_FILECHECK)" filecheck-patterns.txt

=== tests/run-make/profile/Makefile ===
# needs-profiler-support
# ignore-cross-compile

include ../tools.mk

all:
	$(RUSTC) -g -Z profile test.rs
	$(call RUN,test) || exit 1
	[ -e "$(TMPDIR)/test.gcno" ] || (echo "No .gcno file"; exit 1)
	[ -e "$(TMPDIR)/test.gcda" ] || (echo "No .gcda file"; exit 1)
	$(RUSTC) -g -Z profile -Z profile-emit=$(TMPDIR)/abc/abc.gcda test.rs
	$(call RUN,test) || exit 1
	[ -e "$(TMPDIR)/abc/abc.gcda" ] || (echo "gcda file not emitted to defined path"; exit 1)

=== tests/run-make/sepcomp-cci-copies/Makefile ===
include ../tools.mk

# Check that cross-crate inlined items are inlined in all compilation units
# that refer to them, and not in any other compilation units.
# Note that we have to pass `-C codegen-units=6` because up to two CGUs may be
# created for each source module (see `rustc_const_eval::monomorphize::partitioning`).

all:
	$(RUSTC) cci_lib.rs
	$(RUSTC) foo.rs --emit=llvm-ir -C codegen-units=6 \
		-Z inline-in-all-cgus
	[ "$$(cat "$(TMPDIR)"/foo.*.ll | grep -c define\ .*cci_fn)" -eq "2" ]

=== tests/run-make/target-cpu-native/Makefile ===
include ../tools.mk

# only-linux
# only-x86_64
#
# I *really* don't want to deal with a cross-platform way to compare file sizes,
# tests in `make` sort of are awful

all: $(TMPDIR)/out.log
	# Make sure no warnings about "unknown CPU `native`" were emitted
	if [ "$$(wc -c $(TMPDIR)/out.log | cut -d' ' -f 1)" = "0" ]; then \
	  echo no warnings generated; \
	else \
	  exit 1; \
	fi


$(TMPDIR)/out.log:
	$(RUSTC) foo.rs -C target-cpu=native 2>&1 | tee $(TMPDIR)/out.log
	$(call RUN,foo)

=== tests/run-make/unknown-mod-stdin/Makefile ===
# ignore-windows

include ../tools.mk

all:
	echo 'mod unknown;' | $(RUSTC) --crate-type rlib - >$(TMPDIR)/unknown-mod.stdout 2>$(TMPDIR)/unknown-mod.stderr || echo "failed successfully"
	$(RUSTC_TEST_OP) "$(TMPDIR)"/unknown-mod.stdout unknown-mod.stdout
	$(RUSTC_TEST_OP) "$(TMPDIR)"/unknown-mod.stderr unknown-mod.stderr

=== tests/run-make/used/Makefile ===
include ../tools.mk

# ignore-windows-msvc

all:
	$(RUSTC) -C opt-level=3 --emit=obj used.rs
	nm $(TMPDIR)/used.o | $(CGREP) FOO

=== debian/changelog ===
rustc-1.79 (1.79.0+dfsg1ubuntu1-0ubuntu0.24.04) noble; urgency=medium

  * Backport to Noble (LP: #2076205)

 -- Zixing Liu <zixing.liu@canonical.com>  Sun, 18 Aug 2024 19:57:31 -0600

=== debian/control ===
Source: rustc-1.79
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.78 | cargo-1.79 <!pkg.rustc.dlstage0>,
 rustc-1.78 | rustc-1.79 <!pkg.rustc.dlstage0>,
 llvm-18-dev:native,
 llvm-18-tools:native,
 libclang-rt-18-dev (>= 1:18.1.2),
 libclang-common-18-dev (>= 1:18.1.2),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkgconf,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libgit2-dev (>= 1.7.0),
 libgit2-dev (<< 1.8~~),
 libhttp-parser-dev,
 libsqlite3-dev,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-18:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust
